#include "myVector.H"
#include "vec_utility.H"


myVector::myVector() { // default constructor
  Vec temp;
  temp[0]= temp[1] = temp[2] = 0.0;

  VecCopy(base,temp);
  VecCopy(end,temp);
  length = 0.0;
}

myVector::myVector(Point inputoriginP, Point inputdestP) {
  Vec temp;

  VecCopy(base,inputoriginP);
  VecCopy(end,inputdestP);
  VecSub(temp,end,base); // temp = end - base
  length = VecLength(temp);
}

myVector::~myVector() {
}
  
void myVector::setBase(const Point ibase) {

  base[0] = ibase[0];
  base[1] = ibase[1];
  base[2] = ibase[2];
}

void myVector::setEnd (const Point iend ) {

  end[0] = iend[0];
  end[1] = iend[1];
  end[2] = iend[2];
}

void myVector::setLength(float ilength) {
  length = ilength;
}

const Point& myVector::getBase() const{
  return base;
}

const Point& myVector::getEnd() const{
  return end;
}

float myVector::getLength() const {
  return length;
}

void myVector::updateLength() {
  Point diff;
  VecSub(diff, end,base);
  length = VecLength(diff);
}

ostream & operator<< (ostream & output , const myVector & v) {

  output << "myVector base : (" << v.base[0] << "," << v.base[1] << "," << v.base[2] << ")" << endl;
  output << "myVector end  : (" << v.end[0]  << "," << v.end[1]  << "," << v.end[2]  << ")" << endl;

  output << "vector length : " << v.length << endl;

  return output;
}
