
#ifndef  _TREE_H
#define  _TREE_H

#include "protein.H"

class ptrList;
class nodeClass;
class treeClass;
class Protein;

class ptrList {

public:
  ptrList   *nextPtr;
  nodeClass *node;
  float      pathWeight;
  ptrList();
};

class treeClass {

public:
  nodeClass *root;
  treeClass *nextTree;
  treeClass *prevTree;
  int        numNodesInTree;
  int        myTreeName;

  treeClass();
  void removeTree(int *, treeClass* ,treeClass ** , treeClass **,Protein **, const int);
  void printTree();
};

struct queStruct {

  struct queStruct *nextQEntry;
  float timeStamp;
  nodeClass *fromNode;
  nodeClass *toNode;
};

typedef struct queStruct queType;

class nodeClass {

public:
  ptrList *firstLink;
  ptrList *lastLink;
  Protein *myConfig;
  nodeClass *pathPtr;
  char nodeColor;
  float nodeTime;

  nodeClass();
  void addNodeLink    (nodeClass*, float);
  void replaceTreePtr (treeClass*, nodeClass*);
  void setPath        (queType *, nodeClass*, float);
  void setPath_reverse(queType *,nodeClass*, float);
  float reverseWeight(nodeClass*);

};



void nextBestPath (int ** indices, int * numIndices);
// finds best path, then calls expand on that node for next run.


void KBestPaths();// calls nextBestPath K times. 
void findNeighbors (int ** neighborIndices, int *numNeighbors, int startNode, Protein ** allNodes);
void  reportKBestPaths (int K, int startIndex, int endIndex, int numberOfNodes, Protein ** allNodes);



/*  allocates space, and sets its values to false. */
void prepareIncrementedArray(bool ** incremented, int numNodes);
#endif

