#ifndef VEC_UTILITY_H
#define VEC_UTILITY_H


#include <math.h>
#include "myVector.H"
#include <vector>
using namespace std;
typedef Point Vec;

/* dest = source */
void VecCopy(Vec dest, const Vec source);

/* computes A-B = Result */
void VecSub(Vec Result, const Vec A, const Vec B);

void VecScale (Vec Result, const float a, const Vec A);

float VecLength(const Vec P);

float VecDot (const Vec A, const Vec B);

void VecAdd(Vec Result,const Vec A, const Vec B );

void VecCross(Vec Result,const Vec A, const Vec B);

void VecCombine(Vec Result,float a, const Vec A, float b, const Vec B);

int VecEqual (const Vec A, const Vec B);

void VecNormalize(Vec P);

void  obtainVecFromPoints(const Point& p_base, const Point& p_end, Vec& v);

void matMult(mat4 myoutmat, const mat4 mymat1, const mat4 mymat2); 

//void mat3Mul(mat3 myoutmat, const mat3 mat1, const mat3 mat2);

// source of below function : www.eldeeb.com
float matrixInverse( float * pInverse, float * pMatrix, int iRank );

void  vec4Combine(vec4 D, float a, const vec4 unitV, const vec4 C);

void vec4Scale(vec4 Result, float a, const vec4 V);

void vec4Add (vec4 Result, const vec4 A, const vec4 B);

void applyMatToVec4(vec4 outvec,  const mat4 themat, const vec4 invec);

void applyMatToVec4 (vector<float> &  outvec,      const mat4 themat, 
		     const vector<float> &  invec);
//void applyMatToVec3(vec3 outvec,  const mat3 themat, const vec3 invec);

void vec4Sub( vec4 Result, const vec4 V1, const vec4 V2);

void vec4Normalize(vec4);

float vec4Length(const vec4);

//void vec4Copy( vec4 dest, const vec4 source );

/* finds the fourth point in a protein backbone given the previous three atom coordinates, bond lengths, bond angles and dihedral angle. */
void  obtainFourthPoint(const Point& pA, const Point& pB, const Point& pC, Point  pD, float dihedral_angle, const float bond_angle, const float bond_length);

float findRMSD(const Point p1[], const Point p2[], const int numAtoms);

double dihedral_angle (Point A, Point B, Point C, Point D);

void printPoint(Point A);
#endif
